Subject: Re: bug#26909: 25.1; A face for margins

From: Eli Zaretskii <[email-masked]>
Date: Tue, 12 May 2020 20:21:49 +0300

> Cc: [email-masked], [email-masked]
> From: Clément Pit-Claudel <[email-masked]>
> Date: Tue, 12 May 2020 13:06:00 -0400
> 
> > Something like that, yes.  But you will need to make sure
> > extend_face_to_end_of_line is called also for empty lines.  And of
> > course the "silly" changes need to be made less silly. 
> 
> Where the less silly strategy would be to only run the extend_face code when the margins face isn't customized, right?

The other way around, surely?

> > And you need
> > to compute the pixel-width of the stretch glyph, since the code you
> > cited only places a single SPC character there, which is not what you
> > want if the margin is wider than one column.
> 
> Hmm, I think the code already does that?

Does it where?  space_glyph is initiated in init_display_interactive,
and I don't see its pixel_width changed anywhere.  What do you get in
the width of that glyph in the margins?

> >> +    case MARGIN_FACE_ID:		name = Qmargin;			break;
> > 
> > If this is going to be an additional basic face, then why do you call
> > lookup_named_face  and not lookup_basic_face?
> 
> It's because I have no idea what a basic face is, so I just cribbed from places that use the fringe face.  It does things like the following, and I have no idea what those mean:
> 
>       face_id = NILP (face) ? lookup_named_face (w, f, Qfringe, false)
> 	: lookup_derived_face (w, f, face, FRINGE_FACE_ID, 0);
>       if (face_id < 0)
> 	face_id = FRINGE_FACE_ID;

Why not "crib" from a few lines above the code you hacked, where it
gets at the default face?